Subject: Re: [PATCH net-next] qdisc: allow setting default queuing discipline

From: Stephen Hemminger <[email-masked]>
Date: Wed, 28 Aug 2013 09:18:36 -0700

On Tue, 27 Aug 2013 21:57:50 -0700
Eric Dumazet <[email-masked]> wrote:

> On Tue, 2013-08-27 at 21:00 -0700, Eric Dumazet wrote:
> > On Tue, 2013-08-27 at 16:19 -0700, Stephen Hemminger wrote:
> > > By default, the pfifo_fast queue discipline has been used by default
> > > for all devices. But we have better choices now.
> > > 
> > > This patch allow setting the default queueing discipline with sysctl.
> > > This allows easy use of better queueing disciplines on all devices
> > > without having to use tc qdisc scripts. It is intended to allow
> > > an easy path for distributions to make fq_codel or sfq the default
> > > qdisc.
> > > 
> > > This patch also makes pfifo_fast more of a first class qdisc, since
> > > it is now possible to manually override the default and explicitly
> > > use pfifo_fast. The behavior for systems who do not use the sysctl
> > > is unchanged, they still get pfifo_fast
> > > 
> > > Also removes leftover random # in sysctl net core.
> > > 
> > > Signed-off-by: Stephen Hemminger <[email-masked]>
> > > 
> > > ---
> > 
> > I find this quite incredible, because I was going to write such patch
> > tonight ;)
> > 
> > Now I can just relax, thanks so much Stephen !
> > 
> > Acked-by: Eric Dumazet <[email-masked]>
> > 
> 
> I was wondering if we also could redefine the pfifo default, used for
> example in HTB classes.
> 
> ie calls to qdisc_create_dflt( ... &pfifo_qdisc_ops )
> 
> /proc/sys/net/core/default_qdisc would 'define' the default pfifo_fast,
> 
> /proc/sys/net/core/default_pfifo_qdisc would 'define' the default pfifo,
> 
> Or something like that...

Although your idea adds completeness, not sure if it is worth it.
The thing is if user is using HTB, they already are using tc
commands to set it up, therefore the additional script steps to choose some
other qdisc for the leaf nodes doesn't seem like a burden.
Therefore the sysctl doesn't help much and might even create more
confusion because there is now two places to update.